#!/usr/bin/perl
#
use Statistics::OLS;
use Math::FFT;
use Math::Stat;
use Math::Spline qw(spline linsearch binsearch);
use Math::Derivative qw(Derivative2);
use Math::Approx;
use Astro::FITS::CFITSIO qw( :longnames :constants );
use PDL;
use PDL::Fit::Polynomial; 
use PDL::Filter::Linear;
use PGPLOT;  # Load PGPLOT module
use PDL::Fit::Gaussian;
use PDL::Slatec;
use PDL::Image2D;
#use PDL::Matrix;

#require "/work1/ssa/perl/MY/my.pl";
require "/home/sanchez/sda2/code/R3D/my.pl";


if ($#ARGV<2) {
    print "USE: recal_cube.pl CUBE.fits RATIO OUTPUTCUBE.fits\n";
    exit;
}

$infile=$ARGV[0];
$ratio=$ARGV[1];
$outfile=$ARGV[2];


$pdl=rfits($infile);
($nx,$ny,$nz)=$pdl->dims;
$h=$pdl->gethdr;


$pdl=$pdl*$ratio;
$pdl->sethdr($h);
$pdl->wfits($outfile);

